package com.ccnode.codegenerator.U;

package .tmp;

import com.ccnode.codegenerator.U.f;
import com.ccnode.codegenerator.U.o;
import com.ccnode.codegenerator.ae.D;
import com.ccnode.codegenerator.k.a;
import com.ccnode.codegenerator.myconfigurable.Profile;
import com.ccnode.codegenerator.view.C;
import com.intellij.formatting.Block;
import com.intellij.formatting.CustomFormattingModelBuilder;
import com.intellij.formatting.FormattingContext;
import com.intellij.formatting.FormattingDocumentModel;
import com.intellij.formatting.FormattingModel;
import com.intellij.formatting.FormattingModelProvider;
import com.intellij.lang.ASTNode;
import com.intellij.lang.xml.XmlFormattingModel;
import com.intellij.lang.xml.XmlFormattingModelBuilder;
import com.intellij.openapi.application.ApplicationManager;
import com.intellij.openapi.command.CommandProcessor;
import com.intellij.openapi.vfs.VirtualFile;
import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiFile;
import com.intellij.psi.codeStyle.CodeStyleSettings;
import com.intellij.psi.formatter.FormatterUtil;
import com.intellij.psi.formatter.FormattingDocumentModelImpl;
import com.intellij.psi.formatter.xml.XmlFormattingPolicy;
import com.intellij.psi.formatter.xml.XmlPolicy;
import com.intellij.psi.impl.source.SourceTreeToPsiMap;
import com.intellij.psi.impl.source.tree.FileElement;
import com.intellij.psi.impl.source.tree.TreeElement;
import com.intellij.psi.impl.source.tree.TreeUtil;
import org.jetbrains.annotations.NotNull;

public class l implements CustomFormattingModelBuilder {
  private XmlFormattingModelBuilder a = new XmlFormattingModelBuilder();
  
  public boolean isEngagedToFormat(PsiElement paramPsiElement) {
    PsiFile psiFile = paramPsiElement.getContainingFile();
    boolean bool = a.a().useIdeaFormatter();
    if (!bool && D.a.a(psiFile))
      return true; 
    return false;
  }
  
  @NotNull
  public FormattingModel createModel(FormattingContext paramFormattingContext) {
    PsiElement psiElement = paramFormattingContext.getPsiElement();
    CodeStyleSettings codeStyleSettings = paramFormattingContext.getCodeStyleSettings();
    String str = CommandProcessor.getInstance().getCurrentCommandName();
    PsiFile psiFile = psiElement.getContainingFile();
    VirtualFile virtualFile = psiFile.getVirtualFile();
    FormattingModel formattingModel = FormattingModelProvider.createFormattingModelForPsiFile(psiElement.getContainingFile(), (Block)new Object(this, psiElement), codeStyleSettings);
    boolean bool = false;
    if (virtualFile == null)
      return formattingModel; 
    o o = (o)virtualFile.getUserData(C.a);
    if (o != null && o.a()) {
      long l1 = System.currentTimeMillis();
      if (l1 > o.a() && l1 - o.a() < 1500L)
        bool = true; 
    } 
    Profile profile = a.a();
    if (ApplicationManager.getApplication().isUnitTestMode() && profile.getTestWithFormatter())
      bool = true; 
    if (bool) {
      FileElement fileElement1 = TreeUtil.getFileElement((TreeElement)SourceTreeToPsiMap.psiElementToTree(psiElement));
      FormattingDocumentModelImpl formattingDocumentModelImpl1 = FormattingDocumentModelImpl.createOn(psiElement.getContainingFile());
      return (FormattingModel)new XmlFormattingModel(psiElement.getContainingFile(), (Block)a(codeStyleSettings, (ASTNode)fileElement1, formattingDocumentModelImpl1), formattingDocumentModelImpl1);
    } 
    if (str != null && str.equals(FormatterUtil.getReformatBeforeCommitCommandName()))
      return formattingModel; 
    FileElement fileElement = TreeUtil.getFileElement((TreeElement)SourceTreeToPsiMap.psiElementToTree(psiElement));
    FormattingDocumentModelImpl formattingDocumentModelImpl = FormattingDocumentModelImpl.createOn(psiElement.getContainingFile());
    return (FormattingModel)new XmlFormattingModel(psiElement.getContainingFile(), (Block)a(codeStyleSettings, (ASTNode)fileElement, formattingDocumentModelImpl), formattingDocumentModelImpl);
  }
  
  protected f a(CodeStyleSettings paramCodeStyleSettings, ASTNode paramASTNode, FormattingDocumentModelImpl paramFormattingDocumentModelImpl) {
    return new f(paramASTNode, null, null, (XmlFormattingPolicy)new XmlPolicy(paramCodeStyleSettings, (FormattingDocumentModel)paramFormattingDocumentModelImpl), null, null, false);
  }
}
